Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90	(revision 8486)
@@ -17,47 +17,41 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3' :                                  LIM 3.0 sea-ice model
-   !!----------------------------------------------------------------------
-   !!   ice_stp  : sea-ice model time-stepping and update ocean sbc over ice-covered area
-   !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers
-   USE dom_oce         ! ocean space and time domain
-   USE ice             ! LIM-3: ice variables
-   USE ice1D           ! LIM-3: thermodynamical variables
+   !!   'key_lim3'                                    LIM 3.0 sea-ice model
+   !!----------------------------------------------------------------------
+   !!   ice_stp       : sea-ice model time-stepping and update ocean surf. boundary cond. over ice-covered area
+   !!   ice_init      :
+   !!   ice_run_init  : 
+   !!----------------------------------------------------------------------
+   USE oce            ! ocean dynamics and tracers
+   USE dom_oce        ! ocean space and time domain
+   USE c1d            ! 1D vertical configuration
+   USE ice            ! sea-ice: variables
+   USE ice1D          ! sea-ice: thermodynamical 1D variables
    !
-   USE sbc_oce         ! Surface boundary condition: ocean fields
-   USE sbc_ice         ! Surface boundary condition: ice   fields
-   USE iceforcing      ! Surface boundary condition for sea ice
+   USE sbc_oce        ! Surface boundary condition: ocean fields
+   USE sbc_ice        ! Surface boundary condition: ice   fields
+   USE iceforcing     ! sea-ice: Surface boundary condition       !!gm why not icesbc module name
    !
-   USE phycst          ! Define parameters for the routines
-   USE eosbn2          ! equation of state
-   USE icerhg          ! Ice rheology
-   USE iceadv          ! Ice advection
-   USE icethd          ! Ice thermodynamics
-   USE icerdgrft       ! Ice ridging/rafting
-   USE iceupdate       ! sea surface boundary condition
-   USE icedia          ! Ice budget diagnostics
-   USE icewri          ! Ice outputs
-   USE icerst          ! Ice restarts
-   USE icecor          ! Ice corrections
-   USE icevar          ! Ice variables switch
-   USE icectl          !
+   USE phycst         ! Define parameters for the routines
+   USE eosbn2         ! equation of state
+   USE icerhg         ! sea-ice: rheology
+   USE iceadv         ! sea-ice: advection
+   USE icethd         ! sea-ice: thermodynamics
+   USE icerdgrft      ! sea-ice: ridging/rafting
+   USE iceupdate      ! sea-ice: sea surface boundary condition update
+   USE icedia         ! sea-ice: budget diagnostics
+   USE icewri         ! sea-ice: outputs
+   USE icerst         ! sea-ice: restarts
+   USE icecor         ! sea-ice: corrections
+   USE icevar         ! sea-ice: operations
+   USE icectl         ! sea-ice: control
    ! MV MP 2016
-   USE limmp
+   USE limmp          ! sea-ice: melt ponds
    ! END MV MP 2016
-   USE iceist          ! LIM initial state
-   USE icethd_sal      ! LIM ice thermodynamics: salinity
+   USE iceist         ! sea-ice: initial state
+   USE icethd_sal     ! sea-ice: thermodynamics and salinity
    !
-   USE c1d             ! 1D vertical configuration
-   USE in_out_manager  ! I/O manager
-   USE iom             ! I/O manager library
-   USE prtctl          ! Print control
-   USE lib_fortran     !
-   USE lbclnk          ! lateral boundary condition - MPP link
-   USE lib_mpp         ! MPP library
-   USE timing          ! Timing
-
-   USE bdy_oce   , ONLY: ln_bdy
-   USE bdyice          ! unstructured open boundary data
+   USE bdy_oce , ONLY : ln_bdy   ! flag for bdy
+   USE bdyice         ! unstructured open boundary data for sea-ice
 # if defined key_agrif
    USE agrif_ice
@@ -65,15 +59,30 @@
    USE agrif_lim3_interp
 # endif
+   !
+   USE in_out_manager ! I/O manager
+   USE iom            ! I/O manager library
+   USE prtctl         ! Print control
+   USE lib_fortran    ! 
+   USE lbclnk         ! lateral boundary condition - MPP link
+   USE lib_mpp        ! MPP library
+   USE timing         ! Timing
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC ice_stp  ! routine called by sbcmod.F90
-   PUBLIC ice_init ! routine called by sbcmod.F90
+   PUBLIC   ice_stp    ! called by sbcmod.F90
+   PUBLIC   ice_init   ! called by sbcmod.F90
+
+   INTEGER ::              nice_dyn   ! choice of the type of advection scheme
+   !                                  ! associated indices:
+   INTEGER, PARAMETER ::   np_dynNO   = 0   ! no ice dynamics and ice advection
+   INTEGER, PARAMETER ::   np_dynFULL = 1   ! full ice dynamics  (rheology + advection + ridging/rafting + correction)
+   INTEGER, PARAMETER ::   np_dyn     = 2   ! no ridging/rafting (rheology + advection                   + correction)
+   INTEGER, PARAMETER ::   np_dynPURE = 3   ! pure dynamics      (rheology + advection) 
 
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 4.0 , UCL NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icestp.F90 8319 2017-07-11 15:00:44Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -85,6 +94,6 @@
       !!                  ***  ROUTINE ice_stp  ***
       !!
-      !! ** Purpose :   update the ocean surface boundary condition via the
-      !!                Louvain la Neuve Sea Ice Model time stepping
+      !! ** Purpose :   sea-ice model time-stepping and update ocean surface
+      !!              boundary condition over ice-covered area
       !!
       !! ** Method  :   ice model time stepping
@@ -102,66 +111,73 @@
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kt      ! ocean time step
-      INTEGER, INTENT(in) ::   ksbc    ! type of sbc flux ( 1 = user defined formulation, 
-                                       !                    3 = bulk formulation,
-                                       !                    4 = Pure Coupled formulation)
-      INTEGER  ::   jl                 ! dummy loop index
-      !!----------------------------------------------------------------------
-
+      INTEGER, INTENT(in) ::   ksbc    ! flux formulation (user defined, bulk, or Pure Coupled)
+      !
+      INTEGER ::   jl   ! dummy loop index
+      !!----------------------------------------------------------------------
+      !
       IF( nn_timing == 1 )   CALL timing_start('ice_stp')
-
-      !-----------------------!
-      ! --- Ice time step --- !
-      !-----------------------!
-      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
-         
-         ! Ice model time step
-         kt_ice = kt
-
+      !
+      !                                      !-----------------------!
+      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN   ! --- Ice time step --- !
+         !                                   !-----------------------!
+         !
+         kt_ice = kt       ! Ice model time step
+         !
 # if defined key_agrif
          IF( .NOT. Agrif_Root() )  lim_nbstep = MOD( lim_nbstep, Agrif_irhot() * Agrif_Parent(nn_fsbc) / nn_fsbc ) + 1
 # endif
 
-         ! mean surface ocean current at ice velocity point (C-grid dynamics :  U- & V-points as the ocean)
+         !                 ! mean surface ocean current at ice velocity point
          u_oce(:,:) = ssu_m(:,:) * umask(:,:,1)
          v_oce(:,:) = ssv_m(:,:) * vmask(:,:,1)
-
-         ! masked sea surface freezing temperature [Kelvin] (set to rt0 over land)
+!!gm the umask, vmask above is useless as ssu_m, ssv_m are build from masked un,vn (used t be here for B-grid sea-ice)
+
+         !                 ! masked sea surface freezing temperature [Kelvin] (set to rt0 over land)
          CALL eos_fzp( sss_m(:,:) , t_bo(:,:) )
          t_bo(:,:) = ( t_bo(:,:) + rt0 ) * tmask(:,:,1) + rt0 * ( 1._wp - tmask(:,:,1) )
          !
-                                      CALL ice_bef         ! Store previous ice values
+         CALL ice_bef      ! Store previous ice values
+         !
          !------------------------------------------------!
          ! --- Dynamical coupling with the atmosphere --- !
          !------------------------------------------------!
-         ! it provides:
+         ! It provides the following fields used in sea ice model:
          !    utau_ice, vtau_ice = surface ice stress [N/m2]
-         !--------------------------------------------------
-                                      CALL ice_forcing_tau( kt, ksbc, utau_ice, vtau_ice )
+         !------------------------------------------------!
+         CALL ice_forcing_tau( kt, ksbc, utau_ice, vtau_ice )
                                       
-         !-------------------------------------------------------!
-         ! --- ice dynamics and transport (except in 1D case) ---!
-         !-------------------------------------------------------!
-                                      CALL ice_diag0           ! set diag of mass, heat and salt fluxes to 0
-                                      CALL ice_rst_opn( kt )   ! Open Ice restart file
-         !
-         ! --- zap this if no ice dynamics --- !
-         IF( .NOT. lk_c1d .AND. ln_limdyn ) THEN
-                                      CALL ice_rhg( kt )       ! -- rheology  
-                                      CALL ice_adv( kt )       ! -- advection
-            IF( nn_limdyn == 2 .AND. nn_monocat /= 2 )  &      ! -- ridging/rafting
-               &                      CALL ice_rdgrft( kt )         
-            IF( nn_limdyn == 2 )      CALL ice_cor( kt , 1 )   ! -- Corrections
-            !
-         ENDIF
-         ! ---
-         
+         !-------------------------------------!
+         ! --- ice dynamics and advection  --- !
+         !-------------------------------------!
+         CALL ice_diag0             ! set diag of mass, heat and salt fluxes to 0
+         CALL ice_rst_opn( kt )     ! Open Ice restart file (if necessary) 
+         !
+         SELECT CASE( nice_dyn )   
+         CASE ( np_dynFULL )          !==  all dynamical processes  ==!
+            CALL ice_rhg   ( kt )          ! -- rheology  
+            CALL ice_adv   ( kt )          ! -- advection of ice
+            CALL ice_rdgrft( kt )          ! -- ridging/rafting 
+            CALL ice_cor   ( kt , 1 )      ! -- Corrections
+         CASE ( np_dyn )              !==  pure dynamics only ==!   (no ridging/rafting)   (nono cat. case 2)
+            CALL ice_rhg   ( kt )          ! -- rheology  
+            CALL ice_adv   ( kt )          ! -- advection of ice
+            CALL ice_cor   ( kt , 1 )      ! -- Corrections
+         CASE ( np_dynPURE )          !==  pure dynamics only ==!   (nn_limdyn= 0 or 1 )
+            CALL ice_rhg   ( kt )          ! -- rheology  
+            CALL ice_adv   ( kt )          ! -- advection of ice
+         END SELECT
+         !
+         !                          !==  lateral boundary conditions  ==!
 #if defined key_agrif
-         IF( .NOT. Agrif_Root() )     CALL agrif_interp_lim3('T')
+         IF( .NOT. Agrif_Root()     )   CALL agrif_interp_lim3('T')   ! -- AGRIF 
 #endif
-         IF( ln_limthd .AND. ln_bdy ) CALL bdy_ice( kt )       ! -- bdy ice thermo 
-         ! previous lead fraction and ice volume for flux calculations
-                                      CALL ice_var_glo2eqv     ! ht_i and ht_s for ice albedo calculation
-                                      CALL ice_var_agg(1)      ! at_i for coupling 
-                                      CALL ice_bef
+         IF( ln_limthd .AND. ln_bdy )   CALL bdy_ice( kt )            ! -- bdy ice thermo
+         !
+         !
+         !                          !==  previous lead fraction and ice volume for flux calculations
+         !
+         CALL ice_var_glo2eqv            ! ht_i and ht_s for ice albedo calculation
+         CALL ice_var_agg(1)             ! at_i for coupling 
+         CALL ice_bef                    ! Store previous ice values
 
          !------------------------------------------------------!
@@ -169,33 +185,33 @@
          !------------------------------------------------------!
          ! It provides the following fields used in sea ice model:
-         !    fr1_i0  , fr2_i0                         = 1sr & 2nd fraction of qsr penetration in ice  [%]
-         !    emp_oce , emp_ice                        = E-P over ocean and sea ice                    [Kg/m2/s]
-         !    sprecip                                  = solid precipitation                           [Kg/m2/s]
-         !    evap_ice                                 = sublimation                                   [Kg/m2/s]
-         !    qsr_tot , qns_tot                        = solar & non solar heat flux (total)           [W/m2]
-         !    qsr_ice , qns_ice                        = solar & non solar heat flux over ice          [W/m2]
-         !    dqns_ice                                 = non solar  heat sensistivity                  [W/m2]
-         !    qemp_oce, qemp_ice, qprec_ice, qevap_ice = sensible heat (associated with evap & precip) [W/m2]
-         !------------------------------------------------------------------------------------------------------
-                                      CALL ice_forcing_flx( kt, ksbc )
+         !    fr1_i0  , fr2_i0     = 1sr & 2nd fraction of qsr penetration in ice  [%]
+         !    emp_oce , emp_ice    = E-P over ocean and sea ice                    [Kg/m2/s]
+         !    sprecip              = solid precipitation                           [Kg/m2/s]
+         !    evap_ice             = sublimation                                   [Kg/m2/s]
+         !    qsr_tot , qns_tot    = solar & non solar heat flux (total)           [W/m2]
+         !    qsr_ice , qns_ice    = solar & non solar heat flux over ice          [W/m2]
+         !    dqns_ice             = non solar  heat sensistivity                  [W/m2]
+         !    qemp_oce, qemp_ice,  = sensible heat (associated with evap & precip) [W/m2]
+         !    qprec_ice, qevap_ice
+         !------------------------------------------------------!
+         CALL ice_forcing_flx( kt, ksbc )
 
          !----------------------------!
          ! --- ice thermodynamics --- !
          !----------------------------!
-         ! --- zap this if no ice thermo --- !
-         IF( ln_limthd )              CALL ice_thd( kt )        ! -- Ice thermodynamics      
+         IF( ln_limthd )            CALL ice_thd( kt )          ! -- Ice thermodynamics      
 
          ! MV MP 2016
-         IF ( ln_pnd )                CALL lim_mp( kt )         ! -- Melt ponds
+         IF ( ln_pnd )              CALL lim_mp( kt )           ! -- Melt ponds
          ! END MV MP 2016
 
-         IF( ln_limthd )              CALL ice_cor( kt , 2 )    ! -- Corrections
+         IF( ln_limthd )            CALL ice_cor( kt , 2 )      ! -- Corrections
          ! ---
 # if defined key_agrif
-         IF( .NOT. Agrif_Root() )     CALL agrif_update_lim3( kt )
+         IF( .NOT. Agrif_Root() )   CALL agrif_update_lim3( kt )
 # endif
-                                      CALL ice_var_glo2eqv      ! necessary calls (at least for coupling)
-                                      CALL ice_var_agg( 2 )     ! necessary calls (at least for coupling)
-                                      !
+                                    CALL ice_var_glo2eqv        ! necessary calls (at least for coupling)
+                                    CALL ice_var_agg( 2 )       ! necessary calls (at least for coupling)
+                                    !
 !! clem: one should switch the calculation of the fluxes onto the parent grid but the following calls do not work
 !!       moreover it should only be called at the update frequency (as in agrif_lim3_update.F90)
@@ -203,13 +219,13 @@
 !!         IF( .NOT. Agrif_Root() )   CALL Agrif_ChildGrid_To_ParentGrid()
 !!# endif
-                                      CALL ice_update_flx( kt )    ! -- Update surface ocean mass, heat and salt fluxes
+                                    CALL ice_update_flx( kt )   ! -- Update ocean surface mass, heat and salt fluxes
 !!# if defined key_agrif
 !!         IF( .NOT. Agrif_Root() )   CALL Agrif_ParentGrid_To_ChildGrid()
 !!# endif
-         IF( ln_limdiahsb )           CALL ice_dia( kt )     ! -- Diagnostics and outputs 
+         IF( ln_limdiahsb )           CALL ice_dia( kt )        ! -- Diagnostics and outputs 
          !
                                       CALL ice_wri( 1 )         ! -- Ice outputs 
          !
-         IF( kt == nit000 .AND. ln_rstart )   &
+         IF( kt == nit000 .AND. ln_rstart )   &                !!gm  I don't understand the ln_rstart, if needed, add a comment, please
             &                         CALL iom_close( numrir )  ! close input ice restart file
          !
@@ -287,11 +303,11 @@
       IF( ln_limdiahsb) CALL ice_dia_init  ! initialization for diags
       !
-      fr_i(:,:)     = at_i(:,:)         ! initialisation of sea-ice fraction
+      fr_i  (:,:)   = at_i(:,:)         ! initialisation of sea-ice fraction
       tn_ice(:,:,:) = t_su(:,:,:)       ! initialisation of surface temp for coupled simu
       !
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF( gphit(ji,jj) > 0._wp ) THEN  ;  rn_amax_2d(ji,jj) = rn_amax_n  ! NH
-            ELSE                             ;  rn_amax_2d(ji,jj) = rn_amax_s  ! SH
+            IF( gphit(ji,jj) > 0._wp ) THEN   ;   rn_amax_2d(ji,jj) = rn_amax_n  ! NH
+            ELSE                              ;   rn_amax_2d(ji,jj) = rn_amax_s  ! SH
             ENDIF
          END DO
@@ -318,71 +334,84 @@
       !!-------------------------------------------------------------------
       !
-      REWIND( numnam_ice_ref )              ! Namelist namicerun in reference namelist : Parameters for ice
+      REWIND( numnam_ice_ref )      ! Namelist namicerun in reference namelist : Parameters for ice
       READ  ( numnam_ice_ref, namicerun, IOSTAT = ios, ERR = 901)
 901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicerun in reference namelist', lwp )
 
-      REWIND( numnam_ice_cfg )              ! Namelist namicerun in configuration namelist : Parameters for ice
+      REWIND( numnam_ice_cfg )      ! Namelist namicerun in configuration namelist : Parameters for ice
       READ  ( numnam_ice_cfg, namicerun, IOSTAT = ios, ERR = 902 )
 902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicerun in configuration namelist', lwp )
       IF(lwm) WRITE ( numoni, namicerun )
       !
-      REWIND( numnam_ice_ref )              ! Namelist namicediag in reference namelist : Parameters for ice
+      REWIND( numnam_ice_ref )      ! Namelist namicediag in reference namelist : Parameters for ice
       READ  ( numnam_ice_ref, namicediag, IOSTAT = ios, ERR = 903)
 903   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicediag in reference namelist', lwp )
 
-      REWIND( numnam_ice_cfg )              ! Namelist namicediag in configuration namelist : Parameters for ice
+      REWIND( numnam_ice_cfg )      ! Namelist namicediag in configuration namelist : Parameters for ice
       READ  ( numnam_ice_cfg, namicediag, IOSTAT = ios, ERR = 904 )
 904   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicediag in configuration namelist', lwp )
       IF(lwm) WRITE ( numoni, namicediag )
       !
-      IF(lwp) THEN                        ! control print
+      IF(lwp) THEN                  ! control print
          WRITE(numout,*)
          WRITE(numout,*) 'ice_run_init : ice share parameters for dynamics/advection/thermo of sea-ice'
          WRITE(numout,*) ' ~~~~~~'
-         WRITE(numout,*) '   number of ice  categories                              jpl    = ', jpl
-         WRITE(numout,*) '   number of ice  layers                                  nlay_i = ', nlay_i
-         WRITE(numout,*) '   number of snow layers                                  nlay_s = ', nlay_s
-         WRITE(numout,*) '   virtual ITD mono-category param (1-4) or not (0)   nn_monocat = ', nn_monocat
-         WRITE(numout,*) '   maximum ice concentration for NH                              = ', rn_amax_n 
-         WRITE(numout,*) '   maximum ice concentration for SH                              = ', rn_amax_s
-         WRITE(numout,*) '   Ice thermodynamics (T) or not (F)                  ln_limthd  = ', ln_limthd
-         WRITE(numout,*) '   Ice dynamics       (T) or not (F)                  ln_limdyn  = ', ln_limdyn
-         WRITE(numout,*) '     (ln_limdyn=T) Ice dynamics switch                nn_limdyn  = ', nn_limdyn
-         WRITE(numout,*) '       2: total'
-         WRITE(numout,*) '       1: advection only (no diffusion, no ridging/rafting)'
-         WRITE(numout,*) '       0: advection only (as 1 + prescribed velocity, bypass rheology)'
-         WRITE(numout,*) '     (ln_limdyn=T) prescribed u-vel (case nn_limdyn=0)           = ', rn_uice
-         WRITE(numout,*) '     (ln_limdyn=T) prescribed v-vel (case nn_limdyn=0)           = ', rn_vice
+         WRITE(numout,*) '   Namelist namicerun : '
+         WRITE(numout,*) '      number of ice  categories                              jpl    = ', jpl
+         WRITE(numout,*) '      number of ice  layers                                  nlay_i = ', nlay_i
+         WRITE(numout,*) '      number of snow layers                                  nlay_s = ', nlay_s
+         WRITE(numout,*) '      virtual ITD mono-category param (1-4) or not (0)   nn_monocat = ', nn_monocat
+         WRITE(numout,*) '      maximum ice concentration for NH                              = ', rn_amax_n 
+         WRITE(numout,*) '      maximum ice concentration for SH                              = ', rn_amax_s
+         WRITE(numout,*) '      Ice thermodynamics (T) or not (F)                  ln_limthd  = ', ln_limthd
+         WRITE(numout,*) '      Ice dynamics       (T) or not (F)                  ln_limdyn  = ', ln_limdyn
+         WRITE(numout,*) '         associated switch                               nn_limdyn  = ', nn_limdyn
+         WRITE(numout,*) '            =2 all processes (default option)'
+         WRITE(numout,*) '            =1 advection only (no ridging/rafting)'
+         WRITE(numout,*) '            =0 advection only with prescribed velocity given by '
+         WRITE(numout,*) '               a uniform field        (u,v)_ice = (rn_uice,rn_vice) = (', rn_uice,',', rn_vice,')'
          WRITE(numout,*)
-         WRITE(numout,*) '...and ice diagnostics'
-         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~'
-         WRITE(numout,*) '   Diagnose online heat/mass/salt budget     ln_limdiachk  = ', ln_limdiachk
-         WRITE(numout,*) '   Output          heat/mass/salt budget     ln_limdiahsb  = ', ln_limdiahsb
-         WRITE(numout,*) '   control prints in ocean.out for (i,j)=(iiceprt,jiceprt) = ', ln_limctl
-         WRITE(numout,*) '   i-index for control prints (ln_limctl=true)             = ', iiceprt
-         WRITE(numout,*) '   j-index for control prints (ln_limctl=true)             = ', jiceprt
+         WRITE(numout,*) '   Namelist namicediag : '
+         WRITE(numout,*) '      Diagnose online heat/mass/salt budget      ln_limdiachk = ', ln_limdiachk
+         WRITE(numout,*) '      Output          heat/mass/salt budget      ln_limdiahsb = ', ln_limdiahsb
+         WRITE(numout,*) '      control prints for a given grid point         ln_limctl = ', ln_limctl
+         WRITE(numout,*) '         chosen grid point position         (iiceprt,jiceprt) = (', iiceprt,',', jiceprt,')'
       ENDIF
       !
-      IF ( ( jpl > 1 ) .AND. ( nn_monocat == 1 ) ) THEN
+      !                                         !--- check consistency
+      IF ( jpl > 1 .AND. nn_monocat == 1 ) THEN
          nn_monocat = 0
          IF(lwp) WRITE(numout,*)
          IF(lwp) WRITE(numout,*) '   nn_monocat forced to 0 as jpl>1, i.e. multi-category case is chosen'
       ENDIF
-      IF ( ( jpl == 1 ) .AND. ( nn_monocat == 0 ) ) THEN
+      IF ( jpl == 1 .AND. nn_monocat == 0 ) THEN
          CALL ctl_stop( 'STOP', 'ice_run_init : if jpl=1 then nn_monocat should be between 1 and 4' )
       ENDIF
       !
-      ! sea-ice timestep and inverse
-      rdt_ice   = REAL(nn_fsbc) * rdt  
-      r1_rdtice = 1._wp / rdt_ice 
-
-      ! inverse of nlay_i and nlay_s
-      r1_nlay_i = 1._wp / REAL( nlay_i, wp )
+      IF( ln_bdy .AND. ln_limdiachk )   CALL ctl_warn('ice_run_init: online conservation check does not work with BDY')
+      !
+      !                             ! set the choice of ice dynamics
+      IF( lk_c1d .OR. .NOT.ln_limdyn ) THEN
+         nice_dyn = np_dynNO                    !--- no dynamics
+      ELSE
+         SELECT CASE( nn_limdyn )
+         CASE( 2 )                    
+            IF( nn_monocat /= 2 ) THEN          !--- full dynamics (rheology + advection + ridging/rafting + correction)
+               nice_dyn = np_dynFULL
+            ELSE
+               nice_dyn = np_dyn                !--- dynamics without ridging/rafting
+            ENDIF
+         CASE( 0 , 1 )                          !--- dynamics without ridging/rafting and correction 
+            nice_dyn = np_dynPURE
+         END SELECT
+      ENDIF
+      !                                         !--- simple conservative piling, comparable with LIM2
+      l_piling = nn_limdyn == 1 .OR. ( nn_monocat == 2  .AND.  jpl == 1 )
+      !
+      rdt_ice   = REAL(nn_fsbc) * rdt           !--- sea-ice timestep and inverse
+      r1_rdtice = 1._wp / rdt_ice
+      IF( lwp ) WRITE(numout,*) '   ice timestep rdt_ice  = ', rdt_ice
+      !
+      r1_nlay_i = 1._wp / REAL( nlay_i, wp )    !--- inverse of nlay_i and nlay_s
       r1_nlay_s = 1._wp / REAL( nlay_s, wp )
-      !
-      IF( lwp .AND. ln_bdy .AND. ln_limdiachk )  &
-         &   CALL ctl_warn('online conservation check activated but it does not work with BDY')
-      !
-      IF( lwp ) WRITE(numout,*) '   ice timestep rdt_ice  = ', rdt_ice
       !
    END SUBROUTINE ice_run_init
@@ -397,34 +426,34 @@
       !! ** input   :   Namelist namiceitd
       !!-------------------------------------------------------------------
-      INTEGER  ::   ios                 ! Local integer output status for namelist read
+      INTEGER  ::   jl    ! dummy loop index
+      INTEGER  ::   ios   ! Local integer output status for namelist read
+      REAL(wp) ::   zc1, zc2, zc3, zx1          ! local scalars
+      REAL(wp) ::   zhmax, znum, zden, zalpha   !   -      -
+      !!
       NAMELIST/namiceitd/ rn_himean
-      !
-      INTEGER  ::   jl                   ! dummy loop index
-      REAL(wp) ::   zc1, zc2, zc3, zx1   ! local scalars
-      REAL(wp) ::   zhmax, znum, zden, zalpha !
       !!------------------------------------------------------------------
       !
-      REWIND( numnam_ice_ref )              ! Namelist namiceitd in reference namelist : Parameters for ice
+      REWIND( numnam_ice_ref )      ! Namelist namiceitd in reference namelist : Parameters for ice
       READ  ( numnam_ice_ref, namiceitd, IOSTAT = ios, ERR = 905)
 905   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namiceitd in reference namelist', lwp )
 
-      REWIND( numnam_ice_cfg )              ! Namelist namiceitd in configuration namelist : Parameters for ice
+      REWIND( numnam_ice_cfg )      ! Namelist namiceitd in configuration namelist : Parameters for ice
       READ  ( numnam_ice_cfg, namiceitd, IOSTAT = ios, ERR = 906 )
 906   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namiceitd in configuration namelist', lwp )
       IF(lwm) WRITE ( numoni, namiceitd )
       !
-      IF(lwp) THEN                        ! control print
+      IF(lwp) THEN                  ! control print
          WRITE(numout,*)
          WRITE(numout,*) 'ice_itd_init : Initialization of ice cat distribution '
          WRITE(numout,*) '~~~~~~~~~~~~'
-         WRITE(numout,*) '   mean ice thickness in the domain            rn_himean = ', rn_himean
+         WRITE(numout,*) '   Namelist namicerun : '
+         WRITE(numout,*) '      mean ice thickness in the domain               rn_himean = ', rn_himean
       ENDIF
       !
-      !----------------------------------
-      !- Thickness categories boundaries
-      !----------------------------------
-      !
-      !==  h^(-alpha) function  ==!
-      zalpha = 0.05_wp
+      !-----------------------------------!
+      !  Thickness categories boundaries  !
+      !-----------------------------------!
+      !
+      zalpha = 0.05_wp              ! max of each category (from h^(-alpha) function)
       zhmax  = 3._wp * rn_himean
       DO jl = 1, jpl
@@ -441,8 +470,9 @@
       !
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '      Thickness category boundaries '
-      IF(lwp) WRITE(numout,*) '         hi_max ', hi_max(0:jpl)
+      IF(lwp) WRITE(numout,*) '   ===>>>   resulting thickness category boundaries :'
+      IF(lwp) WRITE(numout,*) '            hi_max(:)= ', hi_max(0:jpl)
       !
    END SUBROUTINE ice_itd_init
+
 
    SUBROUTINE ice_bef
@@ -472,9 +502,17 @@
          END DO   
       END DO
-      CALL lbc_lnk_multi( a_i_b, 'T', 1., v_i_b , 'T', 1., v_s_b , 'T', 1., smv_i_b, 'T', 1., &
-         &               oa_i_b, 'T', 1., ht_i_b, 'T', 1., ht_s_b, 'T', 1. )
+      CALL lbc_lnk_multi(  a_i_b, 'T', 1., v_i_b , 'T', 1., ht_i_b, 'T', 1., smv_i_b, 'T', 1.,   &
+         &                oa_i_b, 'T', 1., v_s_b , 'T', 1., ht_s_b, 'T', 1. )
       CALL lbc_lnk( e_i_b, 'T', 1. )
       CALL lbc_lnk( e_s_b, 'T', 1. )
       
+!!gm Question:  here , a_i_b, u_ice and v_ice  are defined over the whole domain, 
+!!gm            so why not just a copy over the whole domain and no lbc_lnk ?
+!!gm            that is some thing like:
+!            at_i_b(:,:)  = SUM( a_i_b(:,:,:), dim=3 )
+!            u_ice_b(:,:) = u_ice(:,:)
+!            v_ice_b(:,:) = v_ice(:,:)
+!    idem for the loop above
+!!gm
       ! ice velocities & total concentration
       DO jj = 2, jpjm1
@@ -486,5 +524,5 @@
       END DO
       CALL lbc_lnk_multi( at_i_b, 'T', 1., u_ice_b , 'U', -1., v_ice_b , 'V', -1. )
-      
+      !
    END SUBROUTINE ice_bef
 
@@ -552,10 +590,8 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   !
    SUBROUTINE ice_stp ( kt, ksbc )     ! Dummy routine
       INTEGER, INTENT(in) ::   kt, ksbc
       WRITE(*,*) 'ice_stp: You should not have seen this print! error?', kt
    END SUBROUTINE ice_stp
-   !
    SUBROUTINE ice_init                 ! Dummy routine
    END SUBROUTINE ice_init
